﻿package  {
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	
	public class matrix01 extends Sprite {
		
		public var numObj:Number = 9;
		public var Squares:Array;
		public var spring:Number = 0.1;
		private var friction:Number = 0.95;
		private var easing:Number = 0.2;
		public function matrix01() {
			init();
		}
		
		public function init() {
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			Squares = [];
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = new Square(80, (Math.random() * 0xDD) << 16 | 0xCC << 8 | 0xCC , i);
				Squares.push(square);
				square.x = 100 + ((stage.stageWidth - 200) / numObj) * i;
				square.y = 100;
				square.nx = square.x;
				square.ny = square.y;
				square.nsx = square.scaleX;
				square.nsy = square.scaleY;
				square.nrot = square.rotation;
				square.ix = square.x;
				square.iy = square.y;
				square.isx = square.scaleX;
				square.isy = square.scaleY;
				square.irot = square.rotation;
				addChild(square);
			}
			
			btn01.addEventListener(MouseEvent.CLICK, btn01Click);
			btn02.addEventListener(MouseEvent.CLICK, btn02Click);
			btn03.addEventListener(MouseEvent.CLICK, btn03Click);
			btn04.addEventListener(MouseEvent.CLICK, btn04Click);
			clear.addEventListener(MouseEvent.CLICK, clearClick);
		}
		
		public function btn01Click(e:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, moveclear2);
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				square.tx = square.x;
				square.ty = square.y;
				square.nx = Math.random() * stage.stageWidth;
				square.ny = Math.random() * stage.stageHeight;
				square.vx = 0;
				square.vy = 0;
			}
			
			addEventListener(Event.ENTER_FRAME, move01);
		}
		
		public function move01(e:Event):void {
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				var matrix:Matrix = square.transform.matrix;
				
				var dx:Number = square.tx - square.nx;
				var dy:Number = square.ty - square.ny;
				var ax:Number = dx * spring;
				var ay:Number = dy * spring;
				square.vx += ax;
				square.vy += ay;
				square.vx *= friction;
				square.vy *= friction;
				square.nx += square.vx;
				square.ny += square.vy;
				
				matrix.createBox(square.nsx, square.nsy, square.nrot, square.nx, square.ny);
				square.transform.matrix = matrix;
			}
		}
		
		public function btn02Click(e:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, moveclear2);
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				square.tsx = 1;
				square.tsy = 1;
				square.vsx = 0;
				square.vsy = 0;
				square.nsx = Math.random() * 8 - 4;
				square.nsy = Math.random() * 8 - 4;
			}
			
			addEventListener(Event.ENTER_FRAME, move02);
		}
		
		public function move02(e:Event):void {
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				var matrix:Matrix = square.transform.matrix;
				
				var dsx:Number = square.tsx - square.nsx;
				var dsy:Number = square.tsy - square.nsy;
				var asx:Number = dsx * spring;
				var asy:Number = dsy * spring;
				square.vsx += asx;
				square.vsy += asy;
				square.vsx *= friction;
				square.vsy *= friction;
				square.nsx += square.vsx;
				square.nsy += square.vsy;
				
				matrix.createBox(square.nsx, square.nsy, square.nrot, square.nx, square.ny);
				square.transform.matrix = matrix;
			}
		}
		
		public function btn03Click(e:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, moveclear2);
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				square.trot = 0;
				square.vrot = 0;
				square.nrot = Math.random() * 90 -45;
			}
			
			addEventListener(Event.ENTER_FRAME, move03);
		}
		
		public function move03(e:Event):void {
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				var matrix:Matrix = square.transform.matrix;
				
				var drot:Number = square.trot - square.nrot;
				var arot:Number = drot * spring;
				square.vrot += arot;
				square.vrot *= friction;
				square.nrot += square.vrot;
				
				matrix.createBox(square.nsx, square.nsy, square.nrot, square.nx, square.ny);
				square.transform.matrix = matrix;
			}
		}
		
		public function btn04Click(e:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, moveclear2);
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				square.tx = square.x;
				square.ty = square.y;
				square.nx = Math.random() * stage.stageWidth;
				square.ny = Math.random() * stage.stageHeight;
				square.vx = 0;
				square.vy = 0;
				
				square.tsx = 1;
				square.tsy = 1;
				square.vsx = 0;
				square.vsy = 0;
				square.nsx = Math.random() * 8 - 4;
				square.nsy = Math.random() * 8 - 4;
				
				square.trot = 0;
				square.vrot = 0;
				square.nrot = Math.random() * 30 -15;

			}
			
			addEventListener(Event.ENTER_FRAME, move04);
		}
		
		public function move04(e:Event):void {
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				var matrix:Matrix = square.transform.matrix;
				
				var dx:Number = square.tx - square.nx;
				var dy:Number = square.ty - square.ny;
				var ax:Number = dx * spring;
				var ay:Number = dy * spring;
				square.vx += ax;
				square.vy += ay;
				square.vx *= friction;
				square.vy *= friction;
				square.nx += square.vx;
				square.ny += square.vy;
				
				var dsx:Number = square.tsx - square.nsx;
				var dsy:Number = square.tsy - square.nsy;
				var asx:Number = dsx * spring;
				var asy:Number = dsy * spring;
				square.vsx += asx;
				square.vsy += asy;
				square.vsx *= friction;
				square.vsy *= friction;
				square.nsx += square.vsx;
				square.nsy += square.vsy;
				
				var drot:Number = square.trot - square.nrot;
				var arot:Number = drot * spring;
				square.vrot += arot;
				square.vrot *= friction;
				square.nrot += square.vrot;
				
				matrix.createBox(square.nsx, square.nsy, square.nrot, square.nx, square.ny);
				square.transform.matrix = matrix;
			}
		}
		
		public function clearClick(e:MouseEvent):void {
			
			removeEventListener(Event.ENTER_FRAME, move01);
			removeEventListener(Event.ENTER_FRAME, move02);
			removeEventListener(Event.ENTER_FRAME, move03);
			removeEventListener(Event.ENTER_FRAME, move04);
			removeEventListener(Event.ENTER_FRAME, moveclear);
			removeEventListener(Event.ENTER_FRAME, moveclear2);
			
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				square.tsx = square.isx;
				square.tsy = square.isy;
				square.trot = square.irot;
				square.tx = square.ix;
				square.ty = square.iy;
				square.vsx = 0;
				square.vsy = 0;
				square.vrot = 0;
				square.vx = 0;
				square.vy = 0;
			}
			
			addEventListener(Event.ENTER_FRAME, moveclear);
		}
		
		public function moveclear(e:Event):void {
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				var matrix:Matrix = square.transform.matrix;
				
				square.vx = (-100 - square.nx) * easing;
				square.vy = (-200 - square.ny) * easing;
				square.vrot = (0 - square.nrot) * easing;
				square.vsx= (15 - square.nsx) * easing;
				square.vsy = (15 - square.nsy) * easing;
				square.nx += square.vx;
				square.ny += square.vy;
				square.nrot += square.vrot;
				square.nsx += square.vsx;
				square.nsy += square.vsy;
				
				if ( i == numObj -1  && square.nsx > 14 ) {
					removeEventListener(Event.ENTER_FRAME, moveclear);
					addEventListener(Event.ENTER_FRAME, moveclear2);
				}

				matrix.createBox(square.nsx, square.nsy, square.nrot, square.nx, square.ny);
				square.transform.matrix = matrix;
			}
		}
		
		public function moveclear2(e:Event):void {
			for (var i:int = 0; i < numObj; i++) {
				var square:Square = Squares[i];
				var matrix:Matrix = square.transform.matrix;
				
				var dx:Number = square.tx - square.nx;
				var dy:Number = square.ty - square.ny;
				var ax:Number = dx * spring;
				var ay:Number = dy * spring;
				square.vx += ax;
				square.vy += ay;
				square.vx *= friction;
				square.vy *= friction;
				square.nx += square.vx;
				square.ny += square.vy;
				
				var dsx:Number = square.tsx - square.nsx;
				var dsy:Number = square.tsy - square.nsy;
				var asx:Number = dsx * spring;
				var asy:Number = dsy * spring;
				square.vsx += asx;
				square.vsy += asy;
				square.vsx *= friction;
				square.vsy *= friction;
				square.nsx += square.vsx;
				square.nsy += square.vsy;
				
				var drot:Number = square.trot - square.nrot;
				var arot:Number = drot * spring;
				square.vrot += arot;
				square.vrot *= friction;
				square.nrot += square.vrot;
				
				matrix.createBox(square.nsx, square.nsy, square.nrot, square.nx, square.ny);
				square.transform.matrix = matrix;
			}
		}
	}
	
}