﻿package {
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	
	public class Square extends Sprite {
		public var radius:Number;
		public var num:Number;
		private var color:uint;
		public var mass:Number = 1;
		public var move01Obj:Object;
		
		public var vx:Number = 0;
		public var vy:Number = 0;
		public var vsx:Number = 0;
		public var vsy:Number = 0;
		public var vrot:Number = 0;
		
		public var tx:Number = 0;
		public var ty:Number = 0;
		public var tsx:Number = 0;
		public var tsy:Number = 0;
		public var trot:Number = 0;
		
		public var nx:Number = 0;
		public var ny:Number = 0;
		public var nsx:Number = 1;
		public var nsy:Number = 1;
		public var nrot:Number = 0;
		
		public var ix:Number = 0;
		public var iy:Number = 0;
		public var isx:Number = 0;
		public var isy:Number = 0;
		public var irot:Number = 0;
		
		public function Square(radius:Number=40, color:uint=0xff0000 , num:Number = 0) {
			this.radius = radius;
			this.color = color;
			this.num = num;
			init();
		}
		public function init():void {
			graphics.beginFill(color);
			graphics.drawRect(0, 0, radius, radius);
			graphics.endFill();
			
			var text:TextField = new TextField();
			var tf:TextFormat = new TextFormat();
			tf.color = 0xFFFFFF;
			tf.size = radius / 2;
			tf.align = "center";
			tf.font = "Arial";
			text.defaultTextFormat = tf;
			text.text = num.toString();
			text.selectable = false;
			text.width = radius;
			text.height = radius;
			text.antiAliasType = AntiAliasType.NORMAL;
			text.embedFonts = true;
			text.x = 0;
			text.y = radius/5;
			addChild(text);
		}
		
	}
}